#pragma semicolon 1

#define DEBUG

#define PLUGIN_AUTHOR ""
#define PLUGIN_VERSION "0.00"

#include <sourcemod>
#include <sdktools>

#pragma newdecls required
Database g_db = null;

public Plugin myinfo = 
{
	name = "",
	author = PLUGIN_AUTHOR,
	description = "",
	version = PLUGIN_VERSION,
	url = ""
};

public void OnPluginStart()
{
	ConnectToDatabase();
}

public void OnClientPostAdminCheck(int client)
{
	if(g_db == null)
		return;
		
	char steamid[32];
	GetClientAuthId(client, AuthId_Steam2, steamid, 32); // Getting client steamid
	
	
	char query[512];
	Format(query, 512, "SELECT steamid FROM retry_table WHERE steamid='%s'", steamid); // Defining the query to select the user steamid from the database
	Handle Query = SQL_Query(g_db, query);
	if(Query == INVALID_HANDLE) // if the query is not valid return
	{
		char error[512];
		SQL_GetError(Query, error, 512);
		LogError(error);
		return;
	}
	
	if(!SQL_FetchRow(Query))
	{
		Format(query, 512, "INSERT INTO retry_table(steamid) VALUES('%s')", steamid); 
		SQL_Query(g_db, query); // Save the user steamid on the database so the retry doesn t loop
		ClientCommand(client, "retry"); // making the player retry
	}

}

void ConnectToDatabase()
{
	if(SQL_CheckConfig("storage-local"))
		Database.Connect(CallbackConnect, "storage-local"); // connect to database
	else
		LogError("No Db");
}

public void CallbackConnect(Database db, char[] error, any data)
{
	if(db == null) // if the db is null(didn t connect), print the error into the server console
		LogError("Can't connect to database. Error: %s", error);
		
	g_db = db;
	SQL_Query(g_db, "CREATE TABLE IF NOT EXISTS retry_table(steamid varchar(32) NOT NULL, PRIMARY KEY (`steamid`))"); // create table
	char sday[10];
	FormatTime(sday, sizeof(sday), "%d", GetTime());
	if(StrEqual(sday,"1"))
	{	
		char query[512];
		Format(query, 512, "SELECT steamid FROM retry_table WHERE steamid LIKE 'deleted%'"); 
		SQL_TQuery(g_db, Month_Callback, query);
	}
}

public void Month_Callback(Handle owner, Handle hndl, const char[] error, any data)
{
	if (hndl == INVALID_HANDLE)
	{
		SetFailState("Faild to connect to the database. Error(%s)", error);
	}
	int row_count = SQL_GetRowCount(hndl);
	char sQuery[256], sCurrentMonth[10];
	FormatTime(sCurrentMonth, sizeof(sCurrentMonth), "%m", GetTime());
	if(row_count > 0)
	{
		char sSQLMonth[10];
		SQL_FetchString(hndl, 0, sSQLMonth, sizeof(sSQLMonth));
		ReplaceString(sSQLMonth, 10, "deleted", "");
		if(!StrEqual(sCurrentMonth,sSQLMonth))
		{
			SQL_Query(g_db, "DELETE FROM `retry_table`");
			Format(sQuery, 256, "INSERT INTO retry_table(steamid) VALUES('deleted%s')", sCurrentMonth);
			SQL_Query(g_db, sQuery);
		}
	}
	else
	{
		Format(sQuery, 256, "INSERT INTO retry_table(steamid) VALUES('deleted%s')", sCurrentMonth);
		SQL_Query(g_db, sQuery);
	}
}

